package componentesconlibreriasmm.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import componentesconlibreriasmm.diagram.edit.parts.ComponenteEditPart;
import componentesconlibreriasmm.diagram.edit.parts.ComponenteNombreCEditPart;
import componentesconlibreriasmm.diagram.edit.parts.ConectorEditPart;
import componentesconlibreriasmm.diagram.edit.parts.LibreriaEditPart;
import componentesconlibreriasmm.diagram.edit.parts.LibreriaNombreLEditPart;
import componentesconlibreriasmm.diagram.edit.parts.SistemaEditPart;
import componentesconlibreriasmm.diagram.part.ComponentesConLibreriasMMDiagramEditorPlugin;
import componentesconlibreriasmm.diagram.part.ComponentesConLibreriasMMVisualIDRegistry;
import componentesconlibreriasmm.diagram.providers.ComponentesConLibreriasMMElementTypes;
import componentesconlibreriasmm.diagram.providers.ComponentesConLibreriasMMParserProvider;

/**
 * @generated
 */
public class ComponentesConLibreriasMMNavigatorLabelProvider extends
		LabelProvider implements ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		ComponentesConLibreriasMMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		ComponentesConLibreriasMMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof ComponentesConLibreriasMMNavigatorItem
				&& !isOwnView(((ComponentesConLibreriasMMNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof ComponentesConLibreriasMMNavigatorGroup) {
			ComponentesConLibreriasMMNavigatorGroup group = (ComponentesConLibreriasMMNavigatorGroup) element;
			return ComponentesConLibreriasMMDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof ComponentesConLibreriasMMNavigatorItem) {
			ComponentesConLibreriasMMNavigatorItem navigatorItem = (ComponentesConLibreriasMMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (ComponentesConLibreriasMMVisualIDRegistry.getVisualID(view)) {
		case SistemaEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://componentesconlibreriasmm/1.0?Sistema", ComponentesConLibreriasMMElementTypes.Sistema_1000); //$NON-NLS-1$
		case ConectorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://componentesconlibreriasmm/1.0?Conector", ComponentesConLibreriasMMElementTypes.Conector_4001); //$NON-NLS-1$
		case LibreriaEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://componentesconlibreriasmm/1.0?Libreria", ComponentesConLibreriasMMElementTypes.Libreria_3001); //$NON-NLS-1$
		case ComponenteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://componentesconlibreriasmm/1.0?Componente", ComponentesConLibreriasMMElementTypes.Componente_2001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = ComponentesConLibreriasMMDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& ComponentesConLibreriasMMElementTypes
						.isKnownElementType(elementType)) {
			image = ComponentesConLibreriasMMElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof ComponentesConLibreriasMMNavigatorGroup) {
			ComponentesConLibreriasMMNavigatorGroup group = (ComponentesConLibreriasMMNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof ComponentesConLibreriasMMNavigatorItem) {
			ComponentesConLibreriasMMNavigatorItem navigatorItem = (ComponentesConLibreriasMMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (ComponentesConLibreriasMMVisualIDRegistry.getVisualID(view)) {
		case SistemaEditPart.VISUAL_ID:
			return getSistema_1000Text(view);
		case ConectorEditPart.VISUAL_ID:
			return getConector_4001Text(view);
		case LibreriaEditPart.VISUAL_ID:
			return getLibreria_3001Text(view);
		case ComponenteEditPart.VISUAL_ID:
			return getComponente_2001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getSistema_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getConector_4001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getLibreria_3001Text(View view) {
		IParser parser = ComponentesConLibreriasMMParserProvider.getParser(
				ComponentesConLibreriasMMElementTypes.Libreria_3001, view
						.getElement() != null ? view.getElement() : view,
				ComponentesConLibreriasMMVisualIDRegistry
						.getType(LibreriaNombreLEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			ComponentesConLibreriasMMDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getComponente_2001Text(View view) {
		IParser parser = ComponentesConLibreriasMMParserProvider.getParser(
				ComponentesConLibreriasMMElementTypes.Componente_2001, view
						.getElement() != null ? view.getElement() : view,
				ComponentesConLibreriasMMVisualIDRegistry
						.getType(ComponenteNombreCEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			ComponentesConLibreriasMMDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return SistemaEditPart.MODEL_ID
				.equals(ComponentesConLibreriasMMVisualIDRegistry
						.getModelID(view));
	}

}
