/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SimpleCMetaModel.provider;


import SimpleCMetaModel.Module;
import SimpleCMetaModel.SimpleCMetaModelFactory;
import SimpleCMetaModel.SimpleCMetaModelPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link SimpleCMetaModel.Module} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ModuleItemProvider
	extends CElementItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModuleItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addExternalsPropertyDescriptor(object);
			addSymbolNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Module_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Module_name_feature", "_UI_Module_type"),
				 SimpleCMetaModelPackage.Literals.MODULE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Externals feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addExternalsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Module_externals_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Module_externals_feature", "_UI_Module_type"),
				 SimpleCMetaModelPackage.Literals.MODULE__EXTERNALS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Symbol Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSymbolNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Module_symbolName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Module_symbolName_feature", "_UI_Module_type"),
				 SimpleCMetaModelPackage.Literals.MODULE__SYMBOL_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(SimpleCMetaModelPackage.Literals.MODULE__FILE);
			childrenFeatures.add(SimpleCMetaModelPackage.Literals.MODULE__FIELDS);
			childrenFeatures.add(SimpleCMetaModelPackage.Literals.MODULE__METHODS);
			childrenFeatures.add(SimpleCMetaModelPackage.Literals.MODULE__NEW_TYPES);
			childrenFeatures.add(SimpleCMetaModelPackage.Literals.MODULE__MACROS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Module.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Module"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Module)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Module_type") :
			getString("_UI_Module_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Module.class)) {
			case SimpleCMetaModelPackage.MODULE__NAME:
			case SimpleCMetaModelPackage.MODULE__SYMBOL_NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case SimpleCMetaModelPackage.MODULE__FILE:
			case SimpleCMetaModelPackage.MODULE__FIELDS:
			case SimpleCMetaModelPackage.MODULE__METHODS:
			case SimpleCMetaModelPackage.MODULE__NEW_TYPES:
			case SimpleCMetaModelPackage.MODULE__MACROS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__FILE,
				 SimpleCMetaModelFactory.eINSTANCE.createFile()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__FIELDS,
				 SimpleCMetaModelFactory.eINSTANCE.createField()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__FIELDS,
				 SimpleCMetaModelFactory.eINSTANCE.createArrayField()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__METHODS,
				 SimpleCMetaModelFactory.eINSTANCE.createMethod()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__NEW_TYPES,
				 SimpleCMetaModelFactory.eINSTANCE.createStructType()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__NEW_TYPES,
				 SimpleCMetaModelFactory.eINSTANCE.createNewPrimitiveType()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__NEW_TYPES,
				 SimpleCMetaModelFactory.eINSTANCE.createUnionType()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__NEW_TYPES,
				 SimpleCMetaModelFactory.eINSTANCE.createNewTypeRedifinition()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__MACROS,
				 SimpleCMetaModelFactory.eINSTANCE.createMacro()));

		newChildDescriptors.add
			(createChildParameter
				(SimpleCMetaModelPackage.Literals.MODULE__MACROS,
				 SimpleCMetaModelFactory.eINSTANCE.createDefine()));
	}

}
