/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SimpleCMetaModel.util;

import SimpleCMetaModel.ArrayField;
import SimpleCMetaModel.Assigment;
import SimpleCMetaModel.AssigmentFunctionCall;
import SimpleCMetaModel.CApplication;
import SimpleCMetaModel.CElement;
import SimpleCMetaModel.CodeLine;
import SimpleCMetaModel.ComposedType;
import SimpleCMetaModel.Define;
import SimpleCMetaModel.Executable;
import SimpleCMetaModel.Field;
import SimpleCMetaModel.File;
import SimpleCMetaModel.For;
import SimpleCMetaModel.FunctionCall;
import SimpleCMetaModel.If;
import SimpleCMetaModel.Library;
import SimpleCMetaModel.LogicOperator;
import SimpleCMetaModel.LoopOperator;
import SimpleCMetaModel.Macro;
import SimpleCMetaModel.Method;
import SimpleCMetaModel.Modifier;
import SimpleCMetaModel.Module;
import SimpleCMetaModel.NewPrimitiveType;
import SimpleCMetaModel.NewType;
import SimpleCMetaModel.NewTypeRedifinition;
import SimpleCMetaModel.NomPrimitiveType;
import SimpleCMetaModel.Operation;
import SimpleCMetaModel.PrimitiveType;
import SimpleCMetaModel.SimpleCMetaModelPackage;
import SimpleCMetaModel.SourceCode;
import SimpleCMetaModel.StructType;
import SimpleCMetaModel.Type;
import SimpleCMetaModel.UnionType;
import SimpleCMetaModel.While;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see SimpleCMetaModel.SimpleCMetaModelPackage
 * @generated
 */
public class SimpleCMetaModelSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SimpleCMetaModelPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleCMetaModelSwitch() {
		if (modelPackage == null) {
			modelPackage = SimpleCMetaModelPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case SimpleCMetaModelPackage.MODULE: {
				Module module = (Module)theEObject;
				T result = caseModule(module);
				if (result == null) result = caseCElement(module);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.FILE: {
				File file = (File)theEObject;
				T result = caseFile(file);
				if (result == null) result = caseCElement(file);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.FIELD: {
				Field field = (Field)theEObject;
				T result = caseField(field);
				if (result == null) result = caseModifier(field);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.METHOD: {
				Method method = (Method)theEObject;
				T result = caseMethod(method);
				if (result == null) result = caseModifier(method);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.MACRO: {
				Macro macro = (Macro)theEObject;
				T result = caseMacro(macro);
				if (result == null) result = caseModifier(macro);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.MODIFIER: {
				Modifier modifier = (Modifier)theEObject;
				T result = caseModifier(modifier);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.PACKAGE: {
				SimpleCMetaModel.Package package_ = (SimpleCMetaModel.Package)theEObject;
				T result = casePackage(package_);
				if (result == null) result = caseCElement(package_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.CAPPLICATION: {
				CApplication cApplication = (CApplication)theEObject;
				T result = caseCApplication(cApplication);
				if (result == null) result = caseCElement(cApplication);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.LIBRARY: {
				Library library = (Library)theEObject;
				T result = caseLibrary(library);
				if (result == null) result = caseCApplication(library);
				if (result == null) result = caseCElement(library);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.EXECUTABLE: {
				Executable executable = (Executable)theEObject;
				T result = caseExecutable(executable);
				if (result == null) result = caseCApplication(executable);
				if (result == null) result = caseCElement(executable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.THREAD: {
				SimpleCMetaModel.Thread thread = (SimpleCMetaModel.Thread)theEObject;
				T result = caseThread(thread);
				if (result == null) result = caseModule(thread);
				if (result == null) result = caseCElement(thread);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.PROCESS: {
				SimpleCMetaModel.Process process = (SimpleCMetaModel.Process)theEObject;
				T result = caseProcess(process);
				if (result == null) result = caseModule(process);
				if (result == null) result = caseCElement(process);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.CELEMENT: {
				CElement cElement = (CElement)theEObject;
				T result = caseCElement(cElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.TYPE: {
				Type type = (Type)theEObject;
				T result = caseType(type);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.PRIMITIVE_TYPE: {
				PrimitiveType primitiveType = (PrimitiveType)theEObject;
				T result = casePrimitiveType(primitiveType);
				if (result == null) result = caseType(primitiveType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.NOM_PRIMITIVE_TYPE: {
				NomPrimitiveType nomPrimitiveType = (NomPrimitiveType)theEObject;
				T result = caseNomPrimitiveType(nomPrimitiveType);
				if (result == null) result = caseType(nomPrimitiveType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.ARRAY_FIELD: {
				ArrayField arrayField = (ArrayField)theEObject;
				T result = caseArrayField(arrayField);
				if (result == null) result = caseField(arrayField);
				if (result == null) result = caseModifier(arrayField);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.DEFINE: {
				Define define = (Define)theEObject;
				T result = caseDefine(define);
				if (result == null) result = caseMacro(define);
				if (result == null) result = caseModifier(define);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.STRUCT_TYPE: {
				StructType structType = (StructType)theEObject;
				T result = caseStructType(structType);
				if (result == null) result = caseComposedType(structType);
				if (result == null) result = caseNewType(structType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.NEW_PRIMITIVE_TYPE: {
				NewPrimitiveType newPrimitiveType = (NewPrimitiveType)theEObject;
				T result = caseNewPrimitiveType(newPrimitiveType);
				if (result == null) result = caseNewType(newPrimitiveType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.NEW_TYPE: {
				NewType newType = (NewType)theEObject;
				T result = caseNewType(newType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.UNION_TYPE: {
				UnionType unionType = (UnionType)theEObject;
				T result = caseUnionType(unionType);
				if (result == null) result = caseComposedType(unionType);
				if (result == null) result = caseNewType(unionType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.COMPOSED_TYPE: {
				ComposedType composedType = (ComposedType)theEObject;
				T result = caseComposedType(composedType);
				if (result == null) result = caseNewType(composedType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.NEW_TYPE_REDIFINITION: {
				NewTypeRedifinition newTypeRedifinition = (NewTypeRedifinition)theEObject;
				T result = caseNewTypeRedifinition(newTypeRedifinition);
				if (result == null) result = caseNewType(newTypeRedifinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.SOURCE_CODE: {
				SourceCode sourceCode = (SourceCode)theEObject;
				T result = caseSourceCode(sourceCode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.LOGIC_OPERATOR: {
				LogicOperator logicOperator = (LogicOperator)theEObject;
				T result = caseLogicOperator(logicOperator);
				if (result == null) result = caseCodeLine(logicOperator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.IF: {
				If if_ = (If)theEObject;
				T result = caseIf(if_);
				if (result == null) result = caseLogicOperator(if_);
				if (result == null) result = caseCodeLine(if_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.WHILE: {
				While while_ = (While)theEObject;
				T result = caseWhile(while_);
				if (result == null) result = caseLoopOperator(while_);
				if (result == null) result = caseCodeLine(while_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.FOR: {
				For for_ = (For)theEObject;
				T result = caseFor(for_);
				if (result == null) result = caseLoopOperator(for_);
				if (result == null) result = caseCodeLine(for_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.CODE_LINE: {
				CodeLine codeLine = (CodeLine)theEObject;
				T result = caseCodeLine(codeLine);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.FUNCTION_CALL: {
				FunctionCall functionCall = (FunctionCall)theEObject;
				T result = caseFunctionCall(functionCall);
				if (result == null) result = caseCodeLine(functionCall);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.LOOP_OPERATOR: {
				LoopOperator loopOperator = (LoopOperator)theEObject;
				T result = caseLoopOperator(loopOperator);
				if (result == null) result = caseCodeLine(loopOperator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.ASSIGMENT: {
				Assigment assigment = (Assigment)theEObject;
				T result = caseAssigment(assigment);
				if (result == null) result = caseCodeLine(assigment);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.OPERATION: {
				Operation operation = (Operation)theEObject;
				T result = caseOperation(operation);
				if (result == null) result = caseCodeLine(operation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleCMetaModelPackage.ASSIGMENT_FUNCTION_CALL: {
				AssigmentFunctionCall assigmentFunctionCall = (AssigmentFunctionCall)theEObject;
				T result = caseAssigmentFunctionCall(assigmentFunctionCall);
				if (result == null) result = caseFunctionCall(assigmentFunctionCall);
				if (result == null) result = caseCodeLine(assigmentFunctionCall);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Module</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Module</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModule(Module object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>File</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>File</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFile(File object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Field</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseField(Field object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Method</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Method</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMethod(Method object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Macro</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Macro</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMacro(Macro object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Modifier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Modifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModifier(Modifier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Package</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Package</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePackage(SimpleCMetaModel.Package object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>CApplication</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>CApplication</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCApplication(CApplication object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Library</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Library</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLibrary(Library object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Executable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Executable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExecutable(Executable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Thread</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Thread</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseThread(SimpleCMetaModel.Thread object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Process</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Process</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProcess(SimpleCMetaModel.Process object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>CElement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>CElement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCElement(CElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseType(Type object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveType(PrimitiveType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Nom Primitive Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Nom Primitive Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNomPrimitiveType(NomPrimitiveType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Array Field</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Array Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseArrayField(ArrayField object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Define</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Define</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDefine(Define object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Struct Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Struct Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStructType(StructType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>New Primitive Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>New Primitive Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNewPrimitiveType(NewPrimitiveType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>New Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>New Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNewType(NewType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Union Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Union Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUnionType(UnionType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composed Type</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composed Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComposedType(ComposedType object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>New Type Redifinition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>New Type Redifinition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNewTypeRedifinition(NewTypeRedifinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Source Code</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Source Code</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSourceCode(SourceCode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Logic Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Logic Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLogicOperator(LogicOperator object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>If</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>If</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIf(If object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>While</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>While</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseWhile(While object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>For</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>For</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFor(For object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Code Line</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Code Line</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCodeLine(CodeLine object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Function Call</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Function Call</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFunctionCall(FunctionCall object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Loop Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Loop Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLoopOperator(LoopOperator object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Assigment</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Assigment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAssigment(Assigment object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Operation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOperation(Operation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Assigment Function Call</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Assigment Function Call</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAssigmentFunctionCall(AssigmentFunctionCall object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //SimpleCMetaModelSwitch
