
#include "staticCircularBuffer.h"

//12. zikloan errorea cuando termina una lectura.
void STATIC_CIRCULAR_BUFFER_init(STATIC_CIRCULAR_BUFFER *obj){
	obj->head = 0;
	obj->tail = 0;
	obj->writing = 0;
	obj->empty = 1;
}
unsigned int STATIC_CIRCULAR_BUFFER_insertChar(STATIC_CIRCULAR_BUFFER *obj , unsigned char data ){
	int freeDataCount , ret;
	freeDataCount = STATIC_CIRCULAR_BUFFER_freeDataCount(obj);
	if (  freeDataCount > 0 ){
		obj->Buffer[ obj->head ] = data ;
		obj->head++;
		if ( obj->head == MAX_BUFFER) obj->head = 0;
		obj->empty = 0;
		ret = 1;
	}else{
		ret = 0;
	}
	return ret;
}

unsigned int  STATIC_CIRCULAR_BUFFER_insertChars(STATIC_CIRCULAR_BUFFER *obj , unsigned char *data, unsigned int length){
	int i,freeDataCount , ret;
	freeDataCount = STATIC_CIRCULAR_BUFFER_freeDataCount(obj);
	if (  freeDataCount > 0 ){
		if (length >  freeDataCount) length = freeDataCount;
		for ( i = 0 ; i < length ; i++){
			obj->Buffer[ obj->head ] = data[i] ;
			obj->head++;
			if ( obj->head == MAX_BUFFER) obj->head = 0;
		}
		obj->empty = 0;
		ret = length;
	}else{
		ret = 0;
	}
	return ret;
}
unsigned char STATIC_CIRCULAR_BUFFER_readChar(STATIC_CIRCULAR_BUFFER *obj ){
	unsigned char ret;
	if ( obj->empty ){
		return 0;
	}else{
		ret = obj->Buffer[ obj->tail ];
		obj->tail++;
		if (obj->tail == MAX_BUFFER) obj->tail = 0;
		if (obj->tail == obj->head) obj->empty = 1;
	}
	return ret;
}
unsigned int STATIC_CIRCULAR_BUFFER_readChars(STATIC_CIRCULAR_BUFFER *obj , unsigned char *data ){

	if (obj->tail == obj->head) obj->empty = 1;
	return 0;
}

unsigned int STATIC_CIRCULAR_BUFFER_freeDataCount(STATIC_CIRCULAR_BUFFER *obj){
	unsigned int ret = 0;
	if ( obj->tail > obj->head ){
		ret = obj->tail-(obj->head );
	}else{
		//cuando la cola y la cabez son iguales puede estar vacio o lleno.
		if (obj->empty){
			ret = MAX_BUFFER;
		}else{
			if ( obj->head == obj->tail ){
				ret = 0;
			}else{
				ret = MAX_BUFFER-(obj->head - obj->tail);
			}

		}
	}
	return ret;
}

unsigned int STATIC_CIRCULAR_BUFFER_dataCount(STATIC_CIRCULAR_BUFFER *obj){
	unsigned int ret = 0;
	if ( obj->tail > obj->head ){
		ret = (obj->head+MAX_BUFFER)-obj->tail;
	}else{
		//cuando la cola y la cabez son iguales puede estar vacio o lleno.
		if ( obj->empty){
			ret = 0;
		}else{
			if ( obj->head == obj->tail ){
				ret = MAX_BUFFER;
			}else{
				ret = (obj->head - obj->tail);
			}

		}

	}
	return ret;
}


unsigned int STATIC_CIRCULAR_BUFFER_existChar(STATIC_CIRCULAR_BUFFER *obj, char car){
	int i = 0, encontrado = 0 , cont = 0 , ret = 0, len;
	i = obj->tail;
	len =  STATIC_CIRCULAR_BUFFER_dataCount(obj);
	while ( ( cont < len ) && !( encontrado ) ){
		if ( obj->Buffer[i] == car ){
			encontrado = 1;
		}
		cont++;
		i++;
		if ( i == MAX_BUFFER) i=0;
	}
	if ( encontrado ){
		ret = cont;
	}
	return ret;
}


