


#ifndef _GestorCabina_H
#define _GestorCabina_H

#ifdef _GestorCabina_C
#define _PUB_GestorCabina
#else
#define _PUB_GestorCabina extern
#endif

typedef struct Tipo_GestorCabina	GestorCabina;


#include "GestorCabinaBehaviour.h"
#include "GestorCabinaEntradas.h"
#include "GestorCabinaSalidas.h"
#include "GestorCabinaParametros.h"
#include "GestorCabinaVarsBat.h"
#include "GestorCabinaTemporizadores.h"
#include "GestorCabinaAverias.h"
#include "GestorCabinaAnomalias.h"
#include "GestorCabinaSenales.h"
#include "GestorCabinaCal_var.h"
#include "GestorCabinaGestorModo.h"
#include "GestorCabinaVertical.h"
#include "GestorCabinaPuertas.h"
#include "GestorCabinaAtributosDeCabinaExternos.h"
#include "GestorCabinaAlgoritmoTrafico.h"
#include "GestorCabinaDesconocidas.h"
#include "GestorCabinaGestorLlamadas.h"
#include "GestorCabinaInterfaceAverias.h"
#include "GestorCabinaGestorLlamadasGestorPuertas.h"
#include "GestorCabinaGestorManIO.h"
#include "GestorCabinaSenalizacion.h"
#include "MANIOBRAAppMANIOBRA.h"

				
				
			
				
					
struct Tipo_GestorCabina{
	Behaviour  *behaviour 
;
	Entradas  *entradas 
;
	Salidas  *salidas 
;
	Parametros  *parametros 
;
	VarsBat  *varsBat 
;
	Temporizadores  *temporizadores 
;
	Averias  *averias 
;
	Anomalias  *anomalias 
;
	BOOLEAN AP_activado 
;
	BOOLEAN noP32_activado 
;
	BOOLEAN CP_activado 
;
	BOOLEAN RecuerdoNuggingBloqueo 
;
	BOOLEAN bPermiso_IR_Local 
;
	BOOLEAN bPermiso_IRM_Local 
;
	BYTE bEstadoReapertura 
;
	BYTE E_abrir_noP32 
;
	BYTE t_tpa 
;
	BYTE E_abrir_AP 
;
	BOOLEAN pri_cabina_CP 
;
	BYTE fms_pu 
;
	BYTE t_retardo_gong_cabina 
;
	BYTE estado_cabina 
;
	BYTE pisos 
;
	BOOLEAN presencia_personas 
;
	BYTE cont_borr_llam 
;
	BYTE cont_NU 
;
	BOOLEAN nop35t1 
;
	BYTE cont_cerrojo 
;
	BYTE P_CONT_MAX_CERROJO 
;
	BOOLEAN pno35t 
;
	BOOLEAN CA_MARCHA_PC 
;
	BYTE EE_API 
;
	BOOLEAN orden_abrir_nivelando 
;
	BYTE ACC_CONDIABRIR 
;
	BYTE ACC_LLAMADA 
;
	BYTE ACC_AP 
;
	BYTE ACC_NOP32 
;
	BYTE ACC_INICTPA 
;
	BOOLEAN bFinCierre 
;
	BYTE ENTRADA_BI 
;
	BYTE CA_REPOSO 
;
	Senales  *senales 
;
	Cal_var  *cal_var 
;
	BYTE carga 
;
	BOOLEAN movimiento_PA_en_curso 
;
	GestorModo  *GestorModo 
;
	Vertical  *Vertical 
;
	Puertas  *Puertas 
;
	AtributosDeCabinaExternos  *AtributosDeCabinaExternos 
;
	AlgoritmoTrafico  *AlgoritmoTrafico 
;
	Desconocidas  *Desconocidas 
;
	GestorLlamadas  *GestorLlamadas 
;
	InterfaceAverias  *InterfaceAverias 
;
	GestorLlamadasGestorPuertas  *GestorLlamadasGestorPuertas 
;
	GestorManIO  *GestorManIO 
;
	Senalizacion  *Senalizacion 
;
};

/*************************************************************
  	Descripcion: accInic()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accInic( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accDetecInicCausa()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accDetecInicCausa( 	GestorCabina  *objeto , 	BYTE causa )

;
/*************************************************************
  	Descripcion: calculo_TPA()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  calculo_TPA( 	GestorCabina  *objeto , 	BYTE tipo )

;
/*************************************************************
  	Descripcion: accBomberoBorrarLlamandas()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accBomberoBorrarLlamandas( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaPermisos()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaPermisos( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaComandos()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaComandos( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactiva_tempo_pon_ON_ALCA_VENT()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactiva_tempo_pon_ON_ALCA_VENT( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: manda_borrar()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  manda_borrar( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaPermisosRefTRUE()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaPermisosRefTRUE( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaPermisosUNI()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaPermisosUNI( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: establecePriCP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  establecePriCP( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activacionGongUniversal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activacionGongUniversal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: cerradaMarcha()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  cerradaMarcha( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: cerradaReposo()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  cerradaReposo( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activacionGongNoUniversal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activacionGongNoUniversal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activacionGongPisoConParada()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activacionGongPisoConParada( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activacionGongPisoConParadaProxima()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activacionGongPisoConParadaProxima( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaPermisosNOUNI()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaPermisosNOUNI( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: accCalculaLlamadaPisoEspecial()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  accCalculaLlamadaPisoEspecial( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: cerrandoTempo()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  cerrandoTempo( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: acc_fin_cierre()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  acc_fin_cierre( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: inic_activaciones()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  inic_activaciones( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activa_ALCA_VENT()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activa_ALCA_VENT( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activa_gong()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activa_gong( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactiva_gong()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactiva_gong( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseoAperturaAccesoAP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseoAperturaAccesoAP( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseosAperturaPorRescate()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseosAperturaPorRescate( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: cabinaCerradaEnNormalyPisoEspecial()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  cabinaCerradaEnNormalyPisoEspecial( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activarAperturaPorAP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activarAperturaPorAP( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactivarAperturarPorAP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactivarAperturarPorAP( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: hayAperturaPorAP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  hayAperturaPorAP( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: activarAperturaPorNoP32()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  activarAperturaPorNoP32( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactivarAperturarPorNoP32()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactivarAperturarPorNoP32( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: hayAperturaPorNoP32()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  hayAperturaPorNoP32( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condi_a_normal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condi_a_normal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condi_c_inspeccion()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condi_c_inspeccion( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condicion6()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condicion6( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condicion812()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condicion812( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: limit_a_cabina()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  limit_a_cabina( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condi_c_normal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condi_c_normal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_a_normal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_a_normal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_c_normal()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_c_normal( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_c_automatico()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_c_automatico( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_c_llamada()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_c_llamada( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_c_socorro()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_c_socorro( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_c_inspeccion()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_c_inspeccion( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_a_nug()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_a_nug( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condi_c_nug()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condi_c_nug( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: condi_a_niv()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  condi_a_niv( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_a_niv()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_a_niv( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_a_forzado()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_a_forzado( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_c_forzado_hidraulico()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_c_forzado_hidraulico( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: fCondiPermisoRetrocesoMec()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BYTE  fCondiPermisoRetrocesoMec( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre_isoniv_PCN()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre_isoniv_PCN( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre_ext_infh()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre_ext_infh( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre_rescate()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre_rescate( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre_BR_RH()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre_BR_RH( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseo_cierre_restauracion()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseo_cierre_restauracion( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: ejecutaRazonApertura()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  ejecutaRazonApertura( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: deseos_c_forzado()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	BOOLEAN  deseos_c_forzado( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: ini_contadores_puertas()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  ini_contadores_puertas( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactiva_salidas()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactiva_salidas( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: desactiva_salidas_inssoc()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  desactiva_salidas_inssoc( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: pulsa_cabina_ON()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  pulsa_cabina_ON( 	GestorCabina  *objeto )

;
/*************************************************************
  	Descripcion: GestorCabina_exec()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_GestorCabina 
	void 	  GestorCabina_exec( 	GestorCabina  *objeto )

;

#endif

			