


#ifndef _Puerta_H
#define _Puerta_H

#ifdef _Puerta_C
#define _PUB_Puerta
#else
#define _PUB_Puerta extern
#endif

typedef struct Tipo_Puerta	Puerta;


#include "PuertaPuertaBehaviour.h"
#include "PuertaPuertaEntradas.h"
#include "PuertaPuertaVarsBat.h"
#include "PuertaPuertaParametros.h"
#include "PuertaPuertaTemporizadores.h"
#include "PuertaPuertaAverias.h"
#include "PuertaPuertaAnomalias.h"
#include "PuertaPuertaSalidas.h"
#include "PuertaInterfaceCabina.h"
#include "PuertaPosicionamiento.h"
#include "PuertaStuff.h"
#include "PuertaPuertaGestorPuertas.h"
#include "PuertaInterfaceLlamadas.h"
#include "PuertainterfaceHaciaModos.h"
#include "PuertaInterfaceTrafico.h"
#include "MANIOBRAAppMANIOBRA.h"

				
				
#define  Num_llamada_piso  1  

#define  Num_lla_VIP  1  

#define  Num_anomalias  1  

			
				
					
struct Tipo_Puerta{
	PuertaBehaviour  *puertaBehaviour 
;
	PuertaEntradas  *entradas 
;
	PuertaVarsBat  *varsBat 
;
	PuertaParametros  *parametros 
;
	BOOLEAN E_cerrar 
;
	BOOLEAN E_abrir 
;
	BOOLEAN E_cierre_forzado 
;
	BOOLEAN fin_abrir 
;
	BOOLEAN fIR_activado 
;
	int 		 id 
;
	BYTE cont_IR 
;
	PuertaTemporizadores  *temporizadores 
;
	PuertaAverias  *averias 
;
	int 		 ACC_IR 
;
	int 		 ACCESO 
;
	BYTE cont_incremento_rec_ir_cerrando 
;
	BOOLEAN E_CEM 
;
	BOOLEAN S_CEM 
;
	BOOLEAN llamada_piso 
[0];
	BOOLEAN lla_VIP 
[0];
	BYTE estado_puerta_ 
;
	PuertaAnomalias  *anomalias 
[0];
	BOOLEAN S_GON 
;
	PuertaSalidas  *salidas 
;
	BYTE OPERADOR_ARTICULADO 
;
	BOOLEAN E_reposo 
;
	InterfaceCabina  *InterfaceCabina 
;
	Posicionamiento  *Posicionamiento 
;
	Stuff  *Stuff 
;
	PuertaGestorPuertas  *PuertaGestorPuertas 
;
	InterfaceLlamadas  *InterfaceLlamadas 
;
	interfaceHaciaModos  *interfaceHaciaModos 
;
	InterfaceTrafico  *InterfaceTrafico 
;
};

/*************************************************************
  	Descripcion: f_IR()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BYTE  f_IR( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: f_IRM()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BYTE  f_IRM( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: fCondiPermisoRetroceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BYTE  fCondiPermisoRetroceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: limit_a()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  limit_a( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: deseoAperturaAcceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  deseoAperturaAcceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: comandosAcceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  comandosAcceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: comandoAccesoSinPermisoApertuta()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  comandoAccesoSinPermisoApertuta( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: comandoAccesoConPermisoApertuta()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  comandoAccesoConPermisoApertuta( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: permisoAcceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  permisoAcceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: recuerdaPermisoAcceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  recuerdaPermisoAcceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: llamadaAcceso()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  llamadaAcceso( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: finalizarApertura()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  finalizarApertura( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: peticionApertura()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  peticionApertura( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: finalizarCierre()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  finalizarCierre( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: peticionCierre()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  peticionCierre( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: peticionCierreForzado()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  peticionCierreForzado( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: calculaPermisosPuerta()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  calculaPermisosPuerta( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: reposoTotalPuerta()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  reposoTotalPuerta( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: presencia_IR_cerrandoPuerta()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  presencia_IR_cerrandoPuerta( 	Puerta  *objeto , 	BYTE ir )

;
/*************************************************************
  	Descripcion: aperturaAP()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  aperturaAP( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: getRef_posi()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  getRef_posi( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: activadoAperturaPorIR()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  activadoAperturaPorIR( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: activadoAperturaPorIRM()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  activadoAperturaPorIRM( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: detectar_LAP_OFF()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  detectar_LAP_OFF( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: calculo_TPA_IR()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  calculo_TPA_IR( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: acc_entrada_IR()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  acc_entrada_IR( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: estaActivadoReposo()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  estaActivadoReposo( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: esModoBombero()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  esModoBombero( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: getP35()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	BOOLEAN  getP35( 	Puerta  *objeto )

;
/*************************************************************
  	Descripcion: Puerta_exec()
  	Param:
  	Return:
  	Data
 **************************************************************/
	_PUB_Puerta 
	void 	  Puerta_exec( 	Puerta  *objeto )

;

#endif

			