package componentesmm.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import componentesmm.diagram.edit.parts.ComponenteEditPart;
import componentesmm.diagram.edit.parts.ComponenteNombreEditPart;
import componentesmm.diagram.edit.parts.ConectorEditPart;
import componentesmm.diagram.edit.parts.SistemaEditPart;
import componentesmm.diagram.part.ComponentesMMDiagramEditorPlugin;
import componentesmm.diagram.part.ComponentesMMVisualIDRegistry;
import componentesmm.diagram.providers.ComponentesMMElementTypes;
import componentesmm.diagram.providers.ComponentesMMParserProvider;

/**
 * @generated
 */
public class ComponentesMMNavigatorLabelProvider extends LabelProvider
		implements ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		ComponentesMMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		ComponentesMMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof ComponentesMMNavigatorItem
				&& !isOwnView(((ComponentesMMNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof ComponentesMMNavigatorGroup) {
			ComponentesMMNavigatorGroup group = (ComponentesMMNavigatorGroup) element;
			return ComponentesMMDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof ComponentesMMNavigatorItem) {
			ComponentesMMNavigatorItem navigatorItem = (ComponentesMMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (ComponentesMMVisualIDRegistry.getVisualID(view)) {
		case ConectorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://componentesmm/1.0?Conector", ComponentesMMElementTypes.Conector_4001); //$NON-NLS-1$
		case SistemaEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://componentesmm/1.0?Sistema", ComponentesMMElementTypes.Sistema_1000); //$NON-NLS-1$
		case ComponenteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://componentesmm/1.0?Componente", ComponentesMMElementTypes.Componente_2001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = ComponentesMMDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& ComponentesMMElementTypes.isKnownElementType(elementType)) {
			image = ComponentesMMElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof ComponentesMMNavigatorGroup) {
			ComponentesMMNavigatorGroup group = (ComponentesMMNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof ComponentesMMNavigatorItem) {
			ComponentesMMNavigatorItem navigatorItem = (ComponentesMMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (ComponentesMMVisualIDRegistry.getVisualID(view)) {
		case ConectorEditPart.VISUAL_ID:
			return getConector_4001Text(view);
		case SistemaEditPart.VISUAL_ID:
			return getSistema_1000Text(view);
		case ComponenteEditPart.VISUAL_ID:
			return getComponente_2001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getConector_4001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getSistema_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getComponente_2001Text(View view) {
		IParser parser = ComponentesMMParserProvider.getParser(
				ComponentesMMElementTypes.Componente_2001,
				view.getElement() != null ? view.getElement() : view,
				ComponentesMMVisualIDRegistry
						.getType(ComponenteNombreEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			ComponentesMMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return SistemaEditPart.MODEL_ID.equals(ComponentesMMVisualIDRegistry
				.getModelID(view));
	}

}
