package org.xtext.ui.syntaxcoloring;

import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.ui.editor.syntaxcoloring.ISemanticHighlightingCalculator;

/*
 * Este mtodo aplica el estilo de la categora lxica DefinitionKeyword
 * (implementado en la clase MyHighlightingConfiguration)
 */
public class MySemanticHighlightingCalculator implements ISemanticHighlightingCalculator {
	
	@Override
	public void provideHighlightingFor(XtextResource resource, IHighlightedPositionAcceptor acceptor) {
		
		if (resource == null || resource.getParseResult() == null) 
			return;

		/* 
		 * Recorre el Abstract Syntax Tree resuelto por el parser para encontrar las
	 	 * palabras clave correspondientes a las definiciones y aplicar el estilo 
		 */ 
		INode root = resource.getParseResult().getRootNode();
		for (INode node : root.getAsTreeIterable()) {

			if (node.getGrammarElement() instanceof Keyword )
			{
				if (node.getText().equalsIgnoreCase("repository")
						|| node.getText().equalsIgnoreCase("componentDef")
						|| node.getText().equalsIgnoreCase("portDef")
						|| node.getText().equalsIgnoreCase("service")
						|| node.getText().equalsIgnoreCase("services"))
				{			
					acceptor.addPosition(node.getOffset(), node.getLength(),
							MyHighlightingConfiguration.DEFINITION_KEYWORD_ID);
				}
			}
		}
	}
}
