package org.xtext.serialization;

import java.io.File;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.resource.XtextResourceSet;
import org.xtext.SimpleComponentsStandaloneSetup;

import simplecomponents.SimplecomponentsPackage;

import com.google.inject.Injector;

/*
 * Para ejecutar: seleccione este fichero en el Package Explorer y haga clic en  
 * la opción "Run as..." -> "Java Application" del menú contextual
 */
public class Xmi2Xtext {

	public static void main(String[] args) {
		
		// Ruta del fichero origen de la serialización 
		File input = new File ("../Models/Serialization/input/modelo1.xmi");
		
		// Ruta del fichero destino de la serialización
		File output = new File ("../Models/Serialization/output/modelo1.scomp");
		
		// Registro del EPackage del meta-modelo SimpleComponents
		EPackage.Registry.INSTANCE.put(SimplecomponentsPackage.eNS_URI, SimplecomponentsPackage.eINSTANCE);
		
		// Creación de un recurso Xtext de salida vacío
		Injector injector = new SimpleComponentsStandaloneSetup().createInjectorAndDoEMFRegistration();
		ResourceSet xtextResourceSet = injector.getInstance(XtextResourceSet.class);
		XtextResource xtextResource = (XtextResource)xtextResourceSet.createResource( 
				URI.createURI("file:" + output.getAbsolutePath()));
		
		// Creación de un recurso XMI con la información del modelo de entrada
		Resource xmiResource = new ResourceSetImpl().getResource(
				URI.createURI("file:" + input.getAbsolutePath()), true);
		
		// Grabación del recurso Xtext con la información del modelo XMI
		xtextResource.getContents().add(xmiResource.getContents().get(0));
		xtextResource.setValidationDisabled(true);
		try {
			xtextResource.save(null);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
